libxml++ 5.0.1

- Main Page
- Related Pages
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
xmlpp::DomParser Class Reference

DOM XML parser. More...

`#include <libxml++/parsers/domparser.h>`

Inheritance diagram for xmlpp::DomParser:
[legend]

## Public Member Functions
LIBXMLPP_API | DomParser ()
| Create a parser with an empty document. More...
LIBXMLPP_API | DomParser (const std::string& filename, bool validate=false)
| Instantiate the parser and parse a document immediately. More...
LIBXMLPP_API | ~DomParser () override
LIBXMLPP_API Document* | get_document () noexcept
| Get the parsed document. More...
LIBXMLPP_API const Document* | get_document () const noexcept
| Get the parsed document. More...
LIBXMLPP_API void | get_xinclude_options (bool& process_xinclude, bool& generate_xinclude_nodes, bool& fixup_base_uris) const noexcept
| Get whether and how the parser will perform XInclude substitution. More...
LIBXMLPP_API | operator bool () const noexcept
| Test whether a document has been parsed. More...
LIBXMLPP_API void | parse_file (const std::string& filename) override
| Parse an XML document from a file. More...
LIBXMLPP_API void | parse_memory (const ustring& contents) override
| Parse an XML document from a string. More...
LIBXMLPP_API void | parse_memory_raw (const unsigned char* contents, size_type bytes_count) override
| Parse an XML document from raw memory. More...
LIBXMLPP_API void | parse_stream (std::istream& in) override
| Parse an XML document from a stream. More...
LIBXMLPP_API void | set_xinclude_options (bool process_xinclude=true, bool generate_xinclude_nodes=true, bool fixup_base_uris=true) noexcept
| Set whether and how the parser will perform XInclude substitution. More...
Public Member Functions inherited from xmlpp::Parser
LIBXMLPP_API | Parser ()
LIBXMLPP_API | ~Parser () override
LIBXMLPP_API bool | get_include_default_attributes () const noexcept
| See set_include_default_attributes(). More...
LIBXMLPP_API void | get_parser_options (int& set_options, int& clear_options) const noexcept
| See set_parser_options(). More...
LIBXMLPP_API bool | get_substitute_entities () const noexcept
| See set_substitute_entities(). More...
LIBXMLPP_API bool | get_throw_messages () const noexcept
| See set_throw_messages(). More...
LIBXMLPP_API bool | get_validate () const noexcept
| See set_validate(). More...
LIBXMLPP_API void | set_include_default_attributes (bool val=true) noexcept
| Set whether default attribute values from the DTD shall be included in the node tree. More...
LIBXMLPP_API void | set_parser_options (int set_options=0, int clear_options=0) noexcept
| Set and/or clear parser option flags. More...
LIBXMLPP_API void | set_substitute_entities (bool val=true) noexcept
| Set whether the parser will automatically substitute entity references with the text of the entities' definitions. More...
LIBXMLPP_API void | set_throw_messages (bool val=true) noexcept
| Set whether the parser will collect and throw error and warning messages. More...
LIBXMLPP_API void | set_validate (bool val=true) noexcept
| By default, the parser will not validate the XML file. More...

## Protected Member Functions
LIBXMLPP_API void | check_xinclude_and_finish_parsing ()
LIBXMLPP_API void | parse_context ()
LIBXMLPP_API void | release_underlying () override
Protected Member Functions inherited from xmlpp::Parser
virtual LIBXMLPP_API void | check_for_error_and_warning_messages ()
virtual LIBXMLPP_API void | check_for_exception ()
virtual LIBXMLPP_API void | handle_exception ()
| To be called in an exception handler. More...
virtual LIBXMLPP_API void | initialize_context ()
virtual LIBXMLPP_API void | on_parser_error (const ustring& message)
virtual LIBXMLPP_API void | on_parser_warning (const ustring& message)
virtual LIBXMLPP_API void | on_validity_error (const ustring& message)
virtual LIBXMLPP_API void | on_validity_warning (const ustring& message)
Protected Member Functions inherited from xmlpp::NonCopyable
| NonCopyable () noexcept
| NonCopyable (const NonCopyable&)=delete
| NonCopyable (NonCopyable&&)=delete
virtual | ~NonCopyable ()
NonCopyable& | operator= (const NonCopyable&)=delete
NonCopyable& | operator= (NonCopyable&&)=delete

## Protected Attributes
Document* | doc_
int | xinclude_options_ = 0
Protected Attributes inherited from xmlpp::Parser
_xmlParserCtxt* | context_
std::unique_ptr< exception > | exception_

## Additional Inherited Members
Public Types inherited from xmlpp::Parser
using | size_type = unsigned int
Protected Types inherited from xmlpp::Parser
enum | MsgType { MsgType::ParserError, MsgType::ParserWarning, MsgType::ValidityError, MsgType::ValidityWarning }
Static Protected Member Functions inherited from xmlpp::Parser
static LIBXMLPP_API void | callback_error_or_warning (MsgType msg_type, void* ctx, const char* msg, va_list var_args)
static LIBXMLPP_API void | callback_parser_error (void* ctx, const char* msg,...)
static LIBXMLPP_API void | callback_parser_warning (void* ctx, const char* msg,...)
static LIBXMLPP_API void | callback_validity_error (void* ctx, const char* msg,...)
static LIBXMLPP_API void | callback_validity_warning (void* ctx, const char* msg,...)

## Detailed Description

DOM XML parser.

DOM = Document Object Model

## Constructor & Destructor Documentation

LIBXMLPP_API xmlpp::DomParser::DomParser | ( |  | ) |

Create a parser with an empty document.

Exceptions

  xmlpp::internal_error | If an empty document can't be created.

LIBXMLPP_API xmlpp::DomParser::DomParser | ( | const std::string & | filename,
|  | bool | validate = `false`
| ) |  |
| explicit

Instantiate the parser and parse a document immediately.

Parameters

  filename | The path to the file.
  validate | Whether the parser should validate the XML.

Exceptions

  xmlpp::internal_error |
  xmlpp::parse_error |
  xmlpp::validity_error |

LIBXMLPP_API xmlpp::DomParser::~DomParser | ( |  | ) |
| override

## Member Function Documentation

LIBXMLPP_API void xmlpp::DomParser::check_xinclude_and_finish_parsing | ( |  | ) |
| protected

LIBXMLPP_API Document* xmlpp::DomParser::get_document | ( |  | ) |
| noexcept

Get the parsed document.

Returns
  A pointer to the parsed document, or `nullptr`.

LIBXMLPP_API const Document* xmlpp::DomParser::get_document | ( |  | ) | const
| noexcept

Get the parsed document.

Returns
  A pointer to the parsed document, or `nullptr`.

LIBXMLPP_API void xmlpp::DomParser::get_xinclude_options | ( | bool & | process_xinclude,
|  | bool & | generate_xinclude_nodes,
|  | bool & | fixup_base_uris
| ) |  | const
| noexcept

Get whether and how the parser will perform XInclude substitution.

Since libxml++ 3.2:

Parameters

  [out] | process_xinclude | Do XInclude substitution on the XML document.
  [out] | generate_xinclude_nodes | Generate XIncludeStart and XIncludeEnd nodes.
  [out] | fixup_base_uris | Add or replace xml:base attributes in included element nodes, if necessary to preserve the target of relative URIs.

LIBXMLPP_API xmlpp::DomParser::operator bool | ( |  | ) | const
| explicit noexcept

Test whether a document has been parsed.

LIBXMLPP_API void xmlpp::DomParser::parse_context | ( |  | ) |
| protected

LIBXMLPP_API void xmlpp::DomParser::parse_file | ( | const std::string & | filename | ) |
| override virtual

Parse an XML document from a file.

If the parser already contains a document, that document and all its nodes are deleted.

Parameters

  filename | The path to the file.

Exceptions

  xmlpp::internal_error |
  xmlpp::parse_error |
  xmlpp::validity_error |

Implements xmlpp::Parser.

LIBXMLPP_API void xmlpp::DomParser::parse_memory | ( | const ustring& | contents | ) |
| override virtual

Parse an XML document from a string.

If the parser already contains a document, that document and all its nodes are deleted.

Parameters

  contents | The XML document as a string.

Exceptions

  xmlpp::internal_error |
  xmlpp::parse_error |
  xmlpp::validity_error |

Implements xmlpp::Parser.

LIBXMLPP_API void xmlpp::DomParser::parse_memory_raw | ( | const unsigned char * | contents,
|  | size_type | bytes_count
| ) |  |
| override virtual

Parse an XML document from raw memory.

If the parser already contains a document, that document and all its nodes are deleted.

Parameters

  contents | The XML document as an array of bytes.
  bytes_count | The number of bytes in the contents array.

Exceptions

  xmlpp::internal_error |
  xmlpp::parse_error |
  xmlpp::validity_error |

Implements xmlpp::Parser.

LIBXMLPP_API void xmlpp::DomParser::parse_stream | ( | std::istream & | in | ) |
| override virtual

Parse an XML document from a stream.

If the parser already contains a document, that document and all its nodes are deleted.

Parameters

  in | The stream.

Exceptions

  xmlpp::internal_error |
  xmlpp::parse_error |
  xmlpp::validity_error |

Implements xmlpp::Parser.

LIBXMLPP_API void xmlpp::DomParser::release_underlying | ( |  | ) |
| override protected virtual

Reimplemented from xmlpp::Parser.

LIBXMLPP_API void xmlpp::DomParser::set_xinclude_options | ( | bool | process_xinclude = `true`,
|  | bool | generate_xinclude_nodes = `true`,
|  | bool | fixup_base_uris = `true`
| ) |  |
| noexcept

Set whether and how the parser will perform XInclude substitution.

Since libxml++ 3.2:

Parameters

  process_xinclude | Do XInclude substitution on the XML document. If `false`, the other parameters have no effect.
  generate_xinclude_nodes | Generate XIncludeStart and XIncludeEnd nodes.
  fixup_base_uris | Add or replace xml:base attributes in included element nodes, if necessary to preserve the target of relative URIs.

## Member Data Documentation

Document* xmlpp::DomParser::doc_
| protected

int xmlpp::DomParser::xinclude_options_ = 0
| protected